﻿var cc = {};
	cc.pi = 3.14159265358979324;
	cc.x_pi = cc.pi * 3000.0 / 180.0;
	cc.MyPoint=function(mLat,mLng){this.lat=mLat;this.lng=mLng;}
	cc.mgTowg =function (lat,lng)
	{
		var mgLat = parseFloat(lat);		
		var mgLon = parseFloat(lng);
		var g_lat, g_lon;
        var point = cc.wgTomg(mgLat, mgLon);
		g_lat = point.lat;
		g_lon = point.lng;
        var d_lat = g_lat - mgLat;  
        var d_lon = g_lon - mgLon;  
        var wgLat = mgLat - d_lat;
        var wgLng = mgLon - d_lon; 			
		return new cc.MyPoint(wgLat,wgLng);
	}	
	cc.wgTomg=function (lat,lng)
	{
		var a = 6378245.0;
		var ee = 0.00669342162296594323;
		var wgLat = parseFloat(lat);		
		var wgLon = parseFloat(lng);
		var dLat = cc.transformLat(wgLon - 105.0, wgLat - 35.0);
        var dLon = cc.transformLon(wgLon - 105.0, wgLat - 35.0);
		var radLat = wgLat / 180.0 * cc.pi;
        var magic = Math.sin(radLat);
        magic = 1 - ee * magic * magic;
        var sqrtMagic = Math.sqrt(magic);
        dLat = (dLat * 180.0) / ((a * (1 - ee)) / (magic * sqrtMagic) * cc.pi);
        dLon = (dLon * 180.0) / (a / sqrtMagic * Math.cos(radLat) * cc.pi);
        mgLat = wgLat + dLat;
        mgLon = wgLon + dLon;
		 
		return new cc.MyPoint(mgLat,mgLon);
	}
	cc.transformLat=function (x,y)
	{
		var ret = -100.0 + 2.0 * x + 3.0 * y + 0.2 * y * y + 0.1 * x * y + 0.2 * Math.sqrt(Math.abs(x));
        ret += (20.0 * Math.sin(6.0 * x * cc.pi) + 20.0 * Math.sin(2.0 * x * cc.pi)) * 2.0 / 3.0;
        ret += (20.0 * Math.sin(y * cc.pi) + 40.0 * Math.sin(y / 3.0 * cc.pi)) * 2.0 / 3.0;
        ret += (160.0 * Math.sin(y / 12.0 * cc.pi) + 320 * Math.sin(y * cc.pi / 30.0)) * 2.0 / 3.0;
        return ret;
	}
	cc.transformLon=function (x,y)
	{
		var ret = 300.0 + x + 2.0 * y + 0.1 * x * x + 0.1 * x * y + 0.1 * Math.sqrt(Math.abs(x));
            ret += (20.0 * Math.sin(6.0 * x * cc.pi) + 20.0 * Math.sin(2.0 * x * cc.pi)) * 2.0 / 3.0;
            ret += (20.0 * Math.sin(x * cc.pi) + 40.0 * Math.sin(x / 3.0 * cc.pi)) * 2.0 / 3.0;
            ret += (150.0 * Math.sin(x / 12.0 * cc.pi) + 300.0 * Math.sin(x / 30.0 * cc.pi)) * 2.0 / 3.0;
           return ret;			
	}
	cc.bd_encrypt=function (lat,lng)
	{
		var gg_lat = parseFloat(lat);
		var gg_lon = parseFloat(lng);
		var x = gg_lon;
        var y=gg_lat;
        var z = Math.sqrt(x * x + y * y) + 0.00002 * Math.sin(y * cc.x_pi);
        var theta = Math.atan2(y, x) + 0.000003 * Math.cos(x * cc.x_pi);
        var bd_lon = z * Math.cos(theta) + 0.0065;
        var bd_lat = z * Math.sin(theta) + 0.006; 
		return new cc.MyPoint(bd_lat,bd_lon);
	}
	
	cc.bd_decrypt=function (lat,lng)
	{
		var bd_lat = parseFloat(lat);
		var bd_lon = parseFloat(lng);
		var x = bd_lon - 0.0065, y = bd_lat - 0.006;
        var z = Math.sqrt(x * x + y * y) - 0.00002 * Math.sin(y * cc.x_pi);
        var theta = Math.atan2(y, x) - 0.000003 * Math.cos(x * cc.x_pi);
        gg_lon = z * Math.cos(theta);
        gg_lat = z * Math.sin(theta);
		return new cc.MyPoint(gg_lat,gg_lon);
	}

	cc.initStyles=function (val){
		if(val==1){
		 
			return [{url:'mapfiles/m1.png',size:new BMap.Size(53,52),opt_anchor:[20,2],textColor:'#ff00ff',opt_textSize:10}, 
					  {url:'mapfiles/m2.png',size:new BMap.Size(56,55),opt_anchor:[22,2],textColor:'#ff0000',opt_textSize:11}, 
					  {url:'mapfiles/m3.png',size:new BMap.Size(66,65),opt_anchor:[28,2],textColor:'#ffffff',opt_textSize:12}];
					 
		}else{
			  
						 return [[{url:'mapfiles/m1.png',height:52,width:53,anchor:[20,22],textColor:'#ff00ff',textSize:10}, 
						{url:'mapfiles/m2.png',height:55,width:56,anchor:[22,23],textColor:'#ff0000',textSize:11}, 
						{url:'mapfiles/m3.png',height:65,width:66,anchor:[28,28],textColor:'#ffffff',textSize:12}  ]];
						 
		}
	}	
	cc.rrArray = [];
	cc.erArray = [];  
	cc.initRect= function(){
		cc.rrArray.push(new cc.Rectangle(49.220400, 79.446200, 42.889900, 96.330000));
		cc.rrArray.push(new cc.Rectangle(54.141500, 109.687200, 39.374200, 135.000200));
		cc.rrArray.push(new cc.Rectangle(42.889900, 73.124600, 29.529700, 124.143255));
		cc.rrArray.push(new cc.Rectangle(29.529700, 82.968400, 26.718600, 97.035200));
		cc.rrArray.push(new cc.Rectangle(29.529700, 97.025300, 20.414096, 124.367395));
		cc.rrArray.push(new cc.Rectangle(20.414096, 107.975793, 17.871542, 111.744104));		
		cc.erArray.push(new cc.Rectangle(25.398623, 119.921265, 21.785006, 122.497559));
		cc.erArray.push(new cc.Rectangle(22.284000, 101.865200, 20.098800, 106.665000));
		cc.erArray.push(new cc.Rectangle(21.542200, 106.452500, 20.487800, 108.051000));
		cc.erArray.push(new cc.Rectangle(55.817500, 109.032300, 50.325700, 119.127000));
		cc.erArray.push(new cc.Rectangle(55.817500, 127.456800, 49.557400, 137.022700));
		cc.erArray.push(new cc.Rectangle(44.892200, 131.266200, 42.569200, 137.022700));
	}
	cc.Rectangle = function(lat1,lng1,lat2,lng2){
	 	this.West = Math.min(lng1, lng2);
		this.North = Math.max(lat1, lat2);
		this.East = Math.max(lng1, lng2);
		this.South = Math.min(lat1, lat2);			
	}
	
	cc.Rectangle.prototype = {
		InRectangle: function(lat,lng){	 		
			return this.West<=lng&&this.East>=lng&&this.North>=lat&&this.South<=lat; 			
		}, 	
	};
	cc.IIC=function (lat,lng){
		for (i = 0; i < cc.rrArray.length; i++){ 
	        if (cc.rrArray[i].InRectangle(lat,lng)){ 
	            for (j = 0; j < cc.erArray.length; j++){ 
	                if (cc.erArray[j].InRectangle(lat,lng))return false; 	                
	            } 
	            return true; 
	        } 
	    } 
	    return false; 
	} 
	cc.coordConvert=function (type,lat,lng){ 
		if( isNaN(lat)|| isNaN(lng))return null;
		if(!cc.IIC(lat,lng))return new cc.MyPoint(lat,lng);
		if(type==bval){
			var convertPoint = cc.wgTomg(lat,lng);
			return cc.bd_encrypt(convertPoint.lat,convertPoint.lng); 
		}else{
			return cc.wgTomg(myLocation.slat,myLocation.slng);  	 
		}
	}
	
	cc.azimuthAngle=function(x1,y1,x2,y2){
		var dx, dy, angle = 0;
		dx = x2 - x1;
		dy = y2 - y1;
		if (x2 == x1) {
			angle = Math.PI / 2.0;
			if (y2 == y1) {
				angle = 0.0;
			} else if (y2 < y1) {
				angle = 3.0 * Math.PI / 2.0;
			}
		} else if ((x2 > x1) && (y2 > y1)) {
			angle = Math.atan(dx / dy);
		} else if ((x2 > x1) && (y2 < y1)) {
			angle = Math.PI / 2 + Math.atan(-dy / dx);
		} else if ((x2 < x1) && (y2 < y1)) {
			angle = Math.PI + Math.atan(dx / dy);
		} else if ((x2 < x1) && (y2 > y1)) {
			angle = 3.0 * Math.PI / 2.0 + Math.atan(dy / -dx);
		}
		return (angle * 180 / Math.PI);
	}
		
	cc.lastAnimObj;
	cc.anim_start= function (obj,status,map){
			if(cc.lastAnimObj)
				cc.anim_stop();				
			cc.lastAnimObj = obj;
			var radius=parseInt(obj.radius);
			if(obj.mCircle)obj.mCircle=null;
			var _strokeColor='#b52b2b',_fillColor='#ca3131';
				if(status){
										/*
										var populationOptions = {
										  strokeColor: _strokeColor,
										  strokeOpacity: 0.2,
										  strokeWeight: 0.01,
										  fillColor: _fillColor,
										  fillOpacity: 0.2
										};
										obj.mCircle = new BMap.Circle(obj.mMarker.getPosition(),radius,populationOptions);										 
										map.addOverlay(obj.mCircle);
										*/
									}else{	
										var populationOptions = {
										  strokeColor: _strokeColor,
										  strokeOpacity: 0.5,
										  strokeWeight: 0.01,
										  fillColor: _fillColor,
										  fillOpacity: 0.2,
										  map: map,
										  center: obj.mMarker.getPosition(),
										  radius: radius
										};
										obj.mCircle = new google.maps.Circle(populationOptions);
									}	
								
        }
		
	cc.anim_stop=function (status){
			if(cc.lastAnimObj){
				if(status){ 
					if(cc.lastAnimObj.mCircle){
											writeLog('清除圆...');
												//map.removeOverlay(cc.lastAnimObj.mCircle);	 
												//cc.lastAnimObj.mCircle=null;
											}
										}else{	
											if(cc.lastAnimObj.mCircle){
												cc.lastAnimObj.mCircle.setMap(null);
												cc.lastAnimObj.mCircle=null; 
											}
										}	
				cc.lastAnimObj=null;
			}			 
		}
		
	//根据景点ID查找对象
	cc.getSearchObject =function (array,id){ 
		for(var i=0;i<array.length;i++){
			if(array[i].id==id)return array[i];
		} 
		return null;
	}
	
	cc.FINAL=6378137.0;
	cc.calcDegree=function (d){	return d*Math.PI/180.0 ;} 
	cc.calcDistance=function (lat1,lng1,lat2,lng2){
		if( isNaN(lat1)|| isNaN(lng1)|| isNaN(lat2)|| isNaN(lng2))return 0;
		var flat = cc.calcDegree(lat1);
		var flng = cc.calcDegree(lng1);
		var tlat = cc.calcDegree(lat2);
		var tlng = cc.calcDegree(lng2);				
		var result = Math.sin(flat)*Math.sin(tlat) ;
		result += Math.cos(flat)*Math.cos(tlat)*Math.cos(flng-tlng) ;
		return Math.acos(result)*cc.FINAL ;		
	} 